#!/usr/bin/perl
#
# Mike Vande Ven Jr.
# March 6, 2006
#
# This script parses the daily/weeklymonthly OS X maintenance script for its last run date.
#
# Revisions:
# January 3, 2009 - Look back two lines to make sure we have the correct date line
# January 5, 2009 - Undo look back two. Implement check for extra data. Merge three files into one that takes a command line argument for the log name.

use strict;
use warnings;

#Get the file name from the command line and open it
my $file = '/var/log/' . $ARGV[0];
&parsefile($file);


#Subroutine to open the file, parse it line by line to look for the last run
#date, and print out that date.
#
# arguments:	0 - The file name
sub parsefile
{
	my $lastdate;
	
	open INPUT, "$_[0]";

	while (<INPUT>)	#For each line of the file (line gets put in $_)
	{
		$lastdate = &checkline($_,$lastdate);
	}
	
	print "$lastdate";

	close INPUT;
}


#Subroutine to check the start of the line to see if a day abbreviation is
#the first thing to appear on the line.
#
# arguments:	0 - The next line of the file
#				1 - The current value of the last found date
# returns:		The new date if a proper line is found, otherwise the last
#				found date.
sub checkline
{
	if ($_[0] =~ /^Mon |^Tue |^Wed |^Thu |^Fri |^Sat |^Sun / && $_[0] !~ /</)
	{
		return $_[0];
	}
	else
	{
		return $_[1];
	}
}